#import "TextureBillowPatch.h"

@implementation TextureBillowPatch
- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];

	[inputSeed setIndexValue:0];
	[inputFrequency setDoubleValue:1.0];
	[inputPersistence setDoubleValue:0.5];
	[inputLacunarity setDoubleValue:2.0];
	[inputOctaves setIndexValue:6];	

	[inputQuality setIndexValue:1];	
	[inputQuality setMaxIndexValue:2];	

	return z;
}

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	if( [inputOctaves indexValue] < 1 )
		[inputOctaves setIndexValue:1];

	module::Billow *billow=new module::Billow;
	billow->SetSeed([inputSeed indexValue]);
	billow->SetFrequency([inputFrequency doubleValue]);
	billow->SetPersistence([inputPersistence doubleValue]);
	billow->SetLacunarity([inputLacunarity doubleValue]);
	billow->SetOctaveCount([inputOctaves indexValue]);
	billow->SetNoiseQuality((noise::NoiseQuality)[inputQuality indexValue]);

	KinemeTexture *t=[[KinemeTexture alloc] initWithTexture:billow];
	[outputTexture setTextureValue:t];
	[t release];

	return YES;
}
@end
