#import "TextureClampPatch.h"

@implementation TextureClampPatch
- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];
	
	[inputBoundLower setDoubleValue:-1.0];
	[inputBoundUpper setDoubleValue:1.0];

	return z;
}

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	module::Module *ta=[[inputTexture textureValue] texture];

	if(ta)
	{
		module::Clamp *clamp=new module::Clamp;
		clamp->SetSourceModule(0,*ta);
		clamp->SetBounds([inputBoundLower doubleValue],[inputBoundUpper doubleValue]);

		KinemeTexture *t=[[KinemeTexture alloc] initWithTexture:clamp];
		[outputTexture setTextureValue:t];
		[t release];
	}
	else
		[outputTexture setTextureValue:nil];

	return YES;
}
@end
