#import "TextureDisplacePatch.h"

@implementation TextureDisplacePatch
- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];
	return z;
}

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	module::Module *st=[[inputTexture textureValue] texture];
	module::Module *tx=[[inputTextureX textureValue] texture];
	module::Module *ty=[[inputTextureY textureValue] texture];
	module::Module *tz=[[inputTextureZ textureValue] texture];

	if(st && tx && ty && tz)
	{
		module::Displace *displace=new module::Displace;
		displace->SetSourceModule(0,*st);
		displace->SetDisplaceModules(*tx,*ty,*tz);

		KinemeTexture *t=[[KinemeTexture alloc] initWithTexture:displace];
		[outputTexture setTextureValue:t];
		[t release];
	}
	else
		[outputTexture setTextureValue:nil];

	return YES;
}
@end
