#import "TexturePerlinPatch.h"

@implementation TexturePerlinPatch
- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];

	[inputSeed setIndexValue:0];
	[inputFrequency setDoubleValue:1.0];
	[inputPersistence setDoubleValue:0.5];
	[inputLacunarity setDoubleValue:2.0];
	[inputOctaves setIndexValue:6];

	[inputQuality setIndexValue:1];	
	[inputQuality setMaxIndexValue:2];	

	return z;
}

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	if( [inputOctaves indexValue] < 1 )
		[inputOctaves setIndexValue:1];

	module::Perlin *perlin=new module::Perlin;
	perlin->SetSeed([inputSeed indexValue]);
	perlin->SetFrequency([inputFrequency doubleValue]);
	perlin->SetPersistence([inputPersistence doubleValue]);
	perlin->SetLacunarity([inputLacunarity doubleValue]);
	perlin->SetOctaveCount([inputOctaves indexValue]);
	perlin->SetNoiseQuality((noise::NoiseQuality)[inputQuality indexValue]);

	KinemeTexture *t=[[KinemeTexture alloc] initWithTexture:perlin];
	[outputTexture setTextureValue:t];
	[t release];

	return YES;
}
@end
