#import "QCPatch.h"
#import "QCPatch-Customization.h"
#import "QCOpenGLContext.h"

#import "QCNumberPort.h"
#import "QCIndexPort.h"
#import "KinemeTexturePort.h"
#import "KinemeTextureRenderer.h"
#import "QCGLImagePort.h"


@interface TextureRenderPatch : QCPatch
{
	KinemeTexturePort *inputTexture;
	QCIndexPort *inputType;
	QCIndexPort *inputPixelsWide;
	QCIndexPort *inputPixelsHigh;

    QCGLImagePort *outputImage;


	unsigned int	currentPixelsWide, currentPixelsHigh;

	KinemeTextureRenderer *_renderer;
}

+ (int)executionMode;
+ (BOOL)allowsSubpatches;
+ (int)timeMode;

- (id)initWithIdentifier:(id)fp8;

- (id)setup:(QCOpenGLContext *)context;
- (void)cleanup:(QCOpenGLContext *)context;

- (void)enable:(QCOpenGLContext *)context;
- (void)disable:(QCOpenGLContext *)context;

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments;
@end