#import "TextureRidgedMultiPatch.h"

@implementation TextureRidgedMultiPatch
- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];

	[inputSeed setIndexValue:0];
	[inputFrequency setDoubleValue:1.0];
	[inputLacunarity setDoubleValue:2.0];
	[inputOctaves setIndexValue:6];

	[inputQuality setIndexValue:1];	
	[inputQuality setMaxIndexValue:2];	

	return z;
}

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	if( [inputOctaves indexValue] < 1 )
		[inputOctaves setIndexValue:1];

	module::RidgedMulti *ridgedMulti=new module::RidgedMulti;
	ridgedMulti->SetSeed([inputSeed indexValue]);
	ridgedMulti->SetFrequency([inputFrequency doubleValue]);
	ridgedMulti->SetLacunarity([inputLacunarity doubleValue]);
	ridgedMulti->SetOctaveCount([inputOctaves indexValue]);
	ridgedMulti->SetNoiseQuality((noise::NoiseQuality)[inputQuality indexValue]);

	KinemeTexture *t=[[KinemeTexture alloc] initWithTexture:ridgedMulti];
	[outputTexture setTextureValue:t];
	[t release];

	return YES;
}
@end
