#import "TextureScaleBiasPatch.h"

@implementation TextureScaleBiasPatch
- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];

	[inputScale setDoubleValue:1.0];
	[inputBias setDoubleValue:0.0];

	return z;
}

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	module::Module *ta=[[inputTexture textureValue] texture];

	if(ta)
	{
		module::ScaleBias *scaleBias=new module::ScaleBias;
		scaleBias->SetSourceModule(0,*ta);
		scaleBias->SetScale([inputScale doubleValue]);
		scaleBias->SetBias([inputBias doubleValue]);

		KinemeTexture *t=[[KinemeTexture alloc] initWithTexture:scaleBias];
		[outputTexture setTextureValue:t];
		[t release];
	}
	else
		[outputTexture setTextureValue:nil];

	return YES;
}
@end
