#import "TextureVoronoiPatch.h"

@implementation TextureVoronoiPatch
- (id)initWithIdentifier:(id)fp8
{
	id z=[super initWithIdentifier:fp8];

	[inputSeed setIndexValue:0];
	[inputFrequency setDoubleValue:1.0];
	[inputDisplacement setDoubleValue:1.0];

	return z;
}

- (BOOL)execute:(QCOpenGLContext *)context time:(double)time arguments:(NSDictionary *)arguments
{
	module::Voronoi *voronoi=new module::Voronoi;
	voronoi->SetSeed([inputSeed indexValue]);
	voronoi->SetFrequency([inputFrequency doubleValue]);
	voronoi->SetDisplacement([inputDisplacement doubleValue]);
	voronoi->EnableDistance([inputDistance booleanValue]);

	KinemeTexture *t=[[KinemeTexture alloc] initWithTexture:voronoi];
	[outputTexture setTextureValue:t];
	[t release];

	return YES;
}
@end
